/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.12 Revision 1.212
1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.212 2008/05/03 16:07:34 dsd Exp $
4
1# kernel.eclass rewrite for a clean base regarding the 2.6 series of kernel 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
2# with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
3# 7#
4# Author: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
5# Copyright 2004 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
6# 10#
7# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
8# thatll be: johnm
9 12
10# added functionality: 13# added functionality:
11# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
12 15
13# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
14# These are as follows: 17# These are as follows:
15# 18#
19# K_USEPV - When setting the EXTRAVERSION variable, it should
20# add PV to the end.
21# this is useful for thigns like wolk. IE:
22# EXTRAVERSION would be something like : -wolk-4.19-r1
16# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be automatically set within the kernel Makefile 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile
17# K_NOUSENAME - if this is set then EXTRAVERSION will not include the first part of ${PN} in EXTRAVERSION 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
18# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, ck-sources, ac-sources) it will use PR (ie: -r5) as the patchset version for EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30# ck-sources, ac-sources) it will use PR (ie: -r5) as
31# the patchset version for
19# - and not use it as a true package revision 32# and not use it as a true package revision
20# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in postinst and can be used to carry additional postinst messages 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34# postinst and can be used to carry additional postinst
35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
21# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38# K_SYMLINK - if this is set, then forcably create symlink anyway
39#
40# K_DEFCONFIG - Allow specifying a different defconfig target.
41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
22 48
23# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which can be supported by the headers ebuild 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
50# can be supported by the headers ebuild
24 51
25# UNIPATCH_LIST - space delimetered list of patches to be applied to the kernel 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
53# kernel
54# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
55# on "<passedstring>*" and not "<passedno#>_*"
56# - this should _NOT_ be used from the ebuild as this is
57# reserved for end users passing excludes from the cli
26# UNIPATCH_DOCS - space delimemeted list of docs to be installed to the doc dir 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
59# the doc dir
60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
61# order, so they are applied in the order passed
27 62
28ECLASS="kernel-2" 63inherit eutils toolchain-funcs versionator multilib
29EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
30 65
66# Added by Daniel Ostrow <dostrow@gentoo.org>
67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
68# I will remove it when I come up with something more reasonable.
69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
70
71export CTARGET=${CTARGET:-${CHOST}}
72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
73 export CTARGET=${CATEGORY/cross-}
74fi
75
31HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
32LICENSE="GPL-2" 77LICENSE="GPL-2"
33IUSE="${IUSE} build"
34SLOT="${KV}"
35 78
79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
80RESTRICT="binchecks strip"
81
82# set LINUX_HOSTCFLAGS if not already set
83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
105
106#Eclass functions only from here onwards ...
107#==============================================================
108handle_genpatches() {
109 local tarball
110 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1
111
112 for i in ${K_WANT_GENPATCHES} ; do
113 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
114 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
115 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
116 done
117}
118
119detect_version() {
120 # this function will detect and set
121 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
122 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
123 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
124
125 if [[ -n ${KV_FULL} ]]; then
126 # we will set this for backwards compatibility.
127 KV=${KV_FULL}
128
129 # we know KV_FULL so lets stop here. but not without resetting S
130 S=${WORKDIR}/linux-${KV_FULL}
131 return
132 fi
133
134 # CKV is used as a comparison kernel version, which is used when
135 # PV doesnt reflect the genuine kernel version.
136 # this gets set to the portage style versioning. ie:
137 # CKV=2.6.11_rc4
138 CKV=${CKV:-${PV}}
139 OKV=${OKV:-${CKV}}
140 OKV=${OKV/_beta/-test}
141 OKV=${OKV/_rc/-rc}
142 OKV=${OKV/-r*}
143 OKV=${OKV/_p*}
144
145 KV_MAJOR=$(get_version_component_range 1 ${OKV})
146 KV_MINOR=$(get_version_component_range 2 ${OKV})
147 KV_PATCH=$(get_version_component_range 3 ${OKV})
148
149 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
150 KV_EXTRA=$(get_version_component_range 4- ${OKV})
151 KV_EXTRA=${KV_EXTRA/[-_]*}
152 else
153 KV_PATCH=$(get_version_component_range 3- ${OKV})
154 fi
155 KV_PATCH=${KV_PATCH/[-_]*}
156
157 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
158
159 RELEASE=${CKV/${OKV}}
160 RELEASE=${RELEASE/_beta}
161 RELEASE=${RELEASE/_rc/-rc}
162 RELEASE=${RELEASE/_pre/-pre}
163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
164 RELEASETYPE=${RELEASE//[0-9]}
165
166 # Now we know that RELEASE is the -rc/-git
167 # and RELEASETYPE is the same but with its numerics stripped
168 # we can work on better sorting EXTRAVERSION.
169 # first of all, we add the release
170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
183 # For some sources we want to use the PV in the extra version
184 # This is because upstream releases with a completely different
185 # versioning scheme.
186 case ${PN/-*} in
187 wolk) K_USEPV=1;;
188 vserver) K_USEPV=1;;
189 esac
190
191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
196
197 # The only messing around which should actually effect this is for KV_EXTRA
198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
200 if [[ -n ${KV_EXTRA} ]]; then
201 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
202 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
205 fi
206
207 # We need to set this using OKV, but we need to set it before we do any
208 # messing around with OKV based on RELEASETYPE
209 KV_FULL=${OKV}${EXTRAVERSION}
210
211 # we will set this for backwards compatibility.
212 S=${WORKDIR}/linux-${KV_FULL}
213 KV=${KV_FULL}
214
215 # -rc-git pulls can be achieved by specifying CKV
216 # for example:
217 # CKV="2.6.11_rc3_pre2"
218 # will pull:
219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
220
221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
226 fi
227
228 if [[ ${RELEASETYPE} == -git ]]; then
229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
232 fi
233
234 if [[ ${RELEASETYPE} == -rc-git ]]; then
235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
240 fi
241
242 debug-print-kernel2-variables
243
244 handle_genpatches
245}
246
247kernel_is() {
248 [[ -z ${OKV} ]] && detect_version
249 local operator test value x=0 y=0 z=0
250
251 case ${1} in
252 lt) operator="-lt"; shift;;
253 gt) operator="-gt"; shift;;
254 le) operator="-le"; shift;;
255 ge) operator="-ge"; shift;;
256 eq) operator="-eq"; shift;;
257 *) operator="-eq";;
258 esac
259
260 for x in ${@}; do
261 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
262 value="${value}${x}"
263 z=$((${z} + 1))
264
265 case ${z} in
266 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
267 test="${test}${KV_MAJOR}";;
268 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
269 test="${test}${KV_MINOR}";;
270 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
271 test="${test}${KV_PATCH}";;
272 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
273 esac
274 done
275
276 [ ${test} ${operator} ${value} ] && return 0 || return 1
277}
278
279kernel_is_2_4() {
280 kernel_is 2 4
281}
282
283kernel_is_2_6() {
284 kernel_is 2 6 || kernel_is 2 5
285}
286
36# capture the sources type and set depends 287# Capture the sources type and set DEPENDs
37if [ "${ETYPE}" == "sources" ] 288if [[ ${ETYPE} == sources ]]; then
38then
39 #console-tools is needed to solve the loadkeys fiasco; binutils version needed to avoid Athlon/PIII/SSE assembler bugs.
40 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
41 >=sys-devel/binutils-2.11.90.0.31 )" 290 >=sys-devel/binutils-2.11.90.0.31 )"
42
43 RDEPEND="${DEPEND}
44 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
45 dev-lang/perl 292 sys-devel/make )
46 sys-apps/module-init-tools 293 virtual/dev-manager"
47 sys-devel/make )"
48 294
49 PROVIDE="virtual/linux-sources virtual/alsa" 295 PROVIDE="virtual/linux-sources"
296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
50 297
298 SLOT="${PVR}"
299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
300 IUSE="symlink build"
51elif [ "${ETYPE}" == "headers" ] 301elif [[ ${ETYPE} == headers ]]; then
52then 302 DESCRIPTION="Linux system headers"
303
304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
307
308 if [[ ${CTARGET} = ${CHOST} ]]; then
309 DEPEND="!virtual/os-headers"
53 PROVIDE="virtual/kernel virtual/os-headers" 310 PROVIDE="virtual/os-headers"
311 SLOT="0"
312 else
313 SLOT="${CTARGET}"
314 fi
54else 315else
55 eerror "Unknown ETYPE=\"${ETYPE}\", must be either \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
56 die 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
57fi 318fi
58 319
59# Grab kernel version from KV 320# Cross-compile support functions
60KV_MAJOR=$(echo ${KV} | cut -d. -f1)
61KV_MINOR=$(echo ${KV} | cut -d. -f2)
62KV_PATCH=$(echo ${KV} | cut -d. -f3)
63KV_PATCH=${KV_PATCH/[-_]*/}
64
65# set LINUX_HOSTCFLAGS if not already set
66[ -z "$LINUX_HOSTCFLAGS" ] && LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
67
68
69#eclass functions only from here onwards.
70#============================================================== 321#==============================================================
71kernel_is_2_4() { 322kernel_header_destdir() {
72 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 4 ] && return 0 || return 1 323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
73} 326}
74 327
75kernel_is_2_6() { 328cross_pre_c_headers() {
76 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 5 -o ${KV_MINOR} -eq 6 ] && return 0 || return 1 329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
77} 330}
78 331
332env_setup_xmakeopts() {
333 # Kernel ARCH != portage ARCH
334 export KARCH=$(tc-arch-kernel)
335
336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
337 # variables properly or bad things happen !
338 xmakeopts="ARCH=${KARCH}"
339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
341 elif type -p ${CHOST}-ar > /dev/null ; then
342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
343 fi
344 export xmakeopts
345}
79 346
80# Unpack functions 347# Unpack functions
81#============================================================== 348#==============================================================
82unpack_2_4() { 349unpack_2_4() {
83 cd ${S}
84 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
85 # so we autogenerate it 351 # so we autogenerate it
86 make mrproper || die "make mrproper died" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
87 make include/linux/version.h || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
88 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
89} 356}
90 357
358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
377}
378
91universal_unpack() { 379universal_unpack() {
380 cd ${WORKDIR}
381 unpack linux-${OKV}.tar.bz2
382 if [[ -d "linux" ]]; then
383 mv linux linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
386 mv linux-${OKV} linux-${KV_FULL} \
387 || die "Unable to move source tree to ${KV_FULL}."
388 fi
389 cd "${S}"
390
92 # remove all backup files 391 # remove all backup files
93 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
94 393
95 if [ -d "${S}/Documentation/DocBook" ] 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
96 then 395 sed -i \
97 cd ${S}/Documentation/DocBook 396 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
98 sed -e "s:db2:docbook2:g" Makefile > Makefile.new \ 397 "${S}"/arch/ppc/Makefile
99 && mv Makefile.new Makefile
100 cd ${S}
101 fi
102} 398}
103 399
104unpack_set_extraversion() { 400unpack_set_extraversion() {
105 # Gentoo Linux uses /boot, so fix 'make install' to work properly and fix EXTRAVERSION
106 cd ${S} 401 cd "${S}"
107 mv Makefile Makefile.orig 402 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
403 cd "${OLDPWD}"
404}
405
406# Should be done after patches have been applied
407# Otherwise patches that modify the same area of Makefile will fail
408unpack_fix_install_path() {
409 cd "${S}"
108 sed -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' \ 410 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
109 -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" \
110 Makefile.orig > Makefile
111 rm Makefile.orig
112} 411}
113 412
114# Compile Functions 413# Compile Functions
115#============================================================== 414#==============================================================
116compile_headers() { 415compile_headers() {
117 local MY_ARCH 416 env_setup_xmakeopts
118 417
119 MY_ARCH=${ARCH} 418 # if we couldnt obtain HOSTCFLAGS from the Makefile,
120 unset ${ARCH} 419 # then set it to something sane
420 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
421 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
422
423 if kernel_is 2 4; then
121 yes "" | make oldconfig 424 yes "" | make oldconfig ${xmakeopts}
122 echo ">>> make oldconfig complete" 425 echo ">>> make oldconfig complete"
123 ARCH=${MY_ARCH} 426 make dep ${xmakeopts}
427 elif kernel_is 2 6; then
428 # 2.6.18 introduces headers_install which means we dont need any
429 # of this crap anymore :D
430 kernel_is ge 2 6 18 && return 0
431
432 # autoconf.h isnt generated unless it already exists. plus, we have
433 # no guarantee that any headers are installed on the system...
434 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
435 || touch include/linux/autoconf.h
436
437 # if K_DEFCONFIG isn't set, force to "defconfig"
438 # needed by mips
439 if [[ -z ${K_DEFCONFIG} ]]; then
440 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
441 case ${CTARGET} in
442 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
443 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
444 *) K_DEFCONFIG="defconfig";;
445 esac
446 else
447 K_DEFCONFIG="defconfig"
448 fi
449 fi
450
451 # if there arent any installed headers, then there also isnt an asm
452 # symlink in /usr/include/, and make defconfig will fail, so we have
453 # to force an include path with $S.
454 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
455 ln -sf asm-${KARCH} "${S}"/include/asm
456 cross_pre_c_headers && return 0
457
458 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
459 if compile_headers_tweak_config ; then
460 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
461 fi
462 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
463 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
464 fi
465}
466
467compile_headers_tweak_config() {
468 # some targets can be very very picky, so let's finesse the
469 # .config based upon any info we may have
470 case ${CTARGET} in
471 sh*)
472 sed -i '/CONFIG_CPU_SH/d' .config
473 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
474 return 0;;
475 esac
476
477 # no changes, so lets do nothing
478 return 1
124} 479}
125 480
126# install functions 481# install functions
127#============================================================== 482#==============================================================
128install_universal() { 483install_universal() {
129 #fix silly permissions in tarball 484 #fix silly permissions in tarball
130 cd ${WORKDIR} 485 cd ${WORKDIR}
131 chown -R root:root * 486 chown -R root:0 *
132 chmod -R a+r-w+X,u+w * 487 chmod -R a+r-w+X,u+w *
488 cd ${OLDPWD}
133} 489}
134 490
135install_headers() { 491install_headers() {
136 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 492 local ddir=$(kernel_header_destdir)
137 [ $(kernel_is_2_6) $? == 0 ] && ln -sf ${S}/include/asm-${ARCH} ${S}/include/asm
138 493
494 # 2.6.18 introduces headers_install which means we dont need any
495 # of this crap anymore :D
496 if kernel_is ge 2 6 18 ; then
497 env_setup_xmakeopts
498 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
499
500 # let other packages install some of these headers
501 rm -rf "${D}"/${ddir}/sound #alsa-headers
502 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
503 return 0
504 fi
505
506 # Do not use "linux/*" as that can cause problems with very long
507 # $S values where the cmdline to cp is too long
139 cd ${S} 508 cd "${S}"
140 dodir /usr/include/linux 509 dodir ${ddir}/linux
141 cp -ax ${S}/include/linux/* ${D}/usr/include/linux 510 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
142 rm -rf ${D}/usr/include/linux/modules 511 rm -rf "${D}"/${ddir}/linux/modules
143 dodir /usr/include/asm 512
144 cp -ax ${S}/include/asm/* ${D}/usr/include/asm 513 # Handle multilib headers and crap
145 514 local multi_dirs="" multi_defs=""
146 if [ $(kernel_is_2_6) $? == 0 ] 515 case $(tc-arch-kernel) in
147 then 516 sparc64)
148 dodir /usr/include/asm-generic 517 multi_dirs="sparc sparc64"
518 multi_defs="!__arch64__ __arch64__"
519 ;;
520 x86_64)
521 multi_dirs="i386 x86_64"
522 multi_defs="__i386__ __x86_64__"
523 ;;
524 ppc64)
525 multi_dirs="ppc ppc64"
526 multi_defs="!__powerpc64__ __powerpc64__"
527 ;;
528 s390x)
529 multi_dirs="s390 s390x"
530 multi_defs="!__s390x__ __s390x__"
531 ;;
532 arm)
533 dodir ${ddir}/asm
534 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
535 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
536 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
537 ;;
538 powerpc)
539 dodir ${ddir}/asm
540 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
541 if [[ -e "${S}"/include/asm-ppc ]] ; then
542 dodir ${ddir}/asm-ppc
543 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
544 fi
545 ;;
546 *)
547 dodir ${ddir}/asm
548 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
549 ;;
550 esac
551 if [[ -n ${multi_dirs} ]] ; then
552 local d ml_inc=""
553 for d in ${multi_dirs} ; do
554 dodir ${ddir}/asm-${d}
555 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
556
557 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
558 multi_defs=${multi_defs#* }
559 done
560 create_ml_includes ${ddir}/asm ${ml_inc}
561 fi
562
563 if kernel_is 2 6; then
564 dodir ${ddir}/asm-generic
149 cp -ax ${S}/include/asm-generic/* ${D}/usr/include/asm-generic 565 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
150 fi 566 fi
567
568 # clean up
569 find "${D}" -name '*.orig' -exec rm -f {} \;
570
571 cd ${OLDPWD}
151} 572}
152 573
153install_sources() { 574install_sources() {
154 local doc 575 local file
155 local docs
156 576
157 cd ${S} 577 cd "${S}"
158 dodir /usr/src 578 dodir /usr/src
159 echo ">>> Copying sources..." 579 echo ">>> Copying sources ..."
160 if [ -d "${WORKDIR}/${KV}/docs/" ] 580
161 then 581 file="$(find ${WORKDIR} -iname "docs" -type d)"
162 for file in $(ls -1 ${WORKDIR}/${KV}/docs/) 582 if [[ -n ${file} ]]; then
163 do 583 for file in $(find ${file} -type f); do
164 echo "XX_${file}*" >> ${S}/patches.txt 584 echo "${file//*docs\/}" >> "${S}"/patches.txt
165 cat ${WORKDIR}/${KV}/docs/${file} >> ${S}/patches.txt 585 echo "===================================================" >> "${S}"/patches.txt
586 cat ${file} >> "${S}"/patches.txt
587 echo "===================================================" >> "${S}"/patches.txt
166 echo "" >> ${S}/patches.txt 588 echo "" >> "${S}"/patches.txt
167 done 589 done
168 fi 590 fi
169 591
170 if [ ! -f ${S}/patches.txt ] 592 if [[ ! -f ${S}/patches.txt ]]; then
171 then
172 # patches.txt is empty so lets use our ChangeLog 593 # patches.txt is empty so lets use our ChangeLog
173 [ -f ${FILESDIR}/../ChangeLog ] && echo "Please check the ebuild ChangeLog for more details." > ${S}/patches.txt 594 [[ -f ${FILESDIR}/../ChangeLog ]] && \
595 echo "Please check the ebuild ChangeLog for more details." \
596 > "${S}"/patches.txt
174 fi 597 fi
175 598
176 for doc in ${UNIPATCH_DOCS} 599 mv ${WORKDIR}/linux* ${D}/usr/src
177 do 600}
178 [ -f ${doc} ] && docs="${docs} ${doc}" 601
602# pkg_preinst functions
603#==============================================================
604preinst_headers() {
605 local ddir=$(kernel_header_destdir)
606 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
607 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
608}
609
610# pkg_postinst functions
611#==============================================================
612postinst_sources() {
613 local MAKELINK=0
614
615 # if we have USE=symlink, then force K_SYMLINK=1
616 use symlink && K_SYMLINK=1
617
618 # if we are to forcably symlink, delete it if it already exists first.
619 if [[ ${K_SYMLINK} > 0 ]]; then
620 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
621 MAKELINK=1
622 fi
623
624 # if the link doesnt exist, lets create it
625 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
626
627 if [[ ${MAKELINK} == 1 ]]; then
628 cd ${ROOT}usr/src
629 ln -sf linux-${KV_FULL} linux
630 cd ${OLDPWD}
631 fi
632
633 # Don't forget to make directory for sysfs
634 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
635
636 echo
637 elog "If you are upgrading from a previous kernel, you may be interested"
638 elog "in the following documents:"
639 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
640 kernel_is_2_6 && elog " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
641 echo
642
643 # if K_EXTRAEINFO is set then lets display it now
644 if [[ -n ${K_EXTRAEINFO} ]]; then
645 echo ${K_EXTRAEINFO} | fmt |
646 while read -s ELINE; do einfo "${ELINE}"; done
647 fi
648
649 # if K_EXTRAELOG is set then lets display it now
650 if [[ -n ${K_EXTRAELOG} ]]; then
651 echo ${K_EXTRAELOG} | fmt |
652 while read -s ELINE; do elog "${ELINE}"; done
653 fi
654
655 # if K_EXTRAEWARN is set then lets display it now
656 if [[ -n ${K_EXTRAEWARN} ]]; then
657 echo ${K_EXTRAEWARN} | fmt |
658 while read -s ELINE; do ewarn "${ELINE}"; done
659 fi
660
661 # optionally display security unsupported message
662 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
663 echo
664 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
665 ewarn "This means that it is likely to be vulnerable to recent security issues."
666 ewarn "For specific information on why this kernel is unsupported, please read:"
667 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
668 fi
669}
670
671postinst_headers() {
672 elog "Kernel headers are usually only used when recompiling your system libc, as"
673 elog "such, following the installation of newer headers, it is advised that you"
674 elog "re-merge your system libc."
675 elog "Failure to do so will cause your system libc to not make use of newer"
676 elog "features present in the updated kernel headers."
677}
678
679# pkg_setup functions
680#==============================================================
681setup_headers() {
682 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
683 for i in ${H_SUPPORTEDARCH}; do
684 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
179 done 685 done
180 686
181 if [ -f ${S}/patches.txt ]; then 687 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
182 docs="${docs} ${S}/patches.txt"
183 fi
184 dodoc ${docs}
185 mv ${WORKDIR}/linux* ${D}/usr/src
186}
187
188# pkg_preinst functions
189#==============================================================
190preinst_headers() {
191 [ -L ${ROOT}usr/include/linux ] && rm ${ROOT}usr/include/linux
192 [ -L ${ROOT}usr/include/asm ] && rm ${ROOT}usr/include/asm
193}
194
195# pkg_postinst functions
196#==============================================================
197postinst_sources() {
198 if [ ! -h ${ROOT}usr/src/linux ]
199 then
200 ln -sf ${ROOT}usr/src/linux-${KV} ${ROOT}usr/src/linux
201 fi
202
203 # Don't forget to make directory for sysfs
204 [ ! -d "${ROOT}/sys" -a $(kernel_is_2_6) $? == 0 ] && mkdir /sys
205
206 echo
207 einfo "After installing a new kernel of any version, it is important"
208 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
209 einfo "created (X.Y is the first 2 parts of your new kernel version)"
210 echo
211 einfo "For example, this kernel will require:"
212 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
213 echo
214
215 # if K_EXTRAEINFO is set then lets display it now
216 if [ -n "${K_EXTRAEINFO}" ]
217 then
218 echo ${K_EXTRAEINFO} | fmt |
219 while read -s ELINE
220 do
221 einfo "${ELINE}"
222 done
223
224 echo 688 echo
225 fi
226
227 # if K_EXTRAEWARN is set then lets display it now
228 if [ -n "${K_EXTRAEWARN}" ]
229 then
230 echo ${K_EXTRAEWARN} | fmt |
231 while read -s ELINE
232 do
233 ewarn "${ELINE}"
234 done
235
236 echo
237 fi
238}
239
240postinst_headers() {
241 echo
242 einfo "Kernel headers are usually only used when recompiling glibc."
243 einfo "Following the installation of newer headers it is advised that"
244 einfo "you re-merge glibc as follows:"
245 einfo "# emerge glibc"
246 einfo "Failure to do so will cause glibc to not make use of newer"
247 einfo "features present in the updated kernelheaders."
248 echo
249}
250
251# pkg_setup functions
252#==============================================================
253setup_headers() {
254 ARCH=$(uname -m | sed -e s/[i].86/i386/ -e s/x86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/amd64/x86_64/)
255 [ "$ARCH" == "sparc" -a "$PROFILE_ARCH" == "sparc64" ] && ARCH="sparc64"
256
257 [ -z "${H_SUPPORTEDARCH}" ] && H_SUPPORTEDARCH="${PN/-*/}"
258 for i in ${H_SUPPORTEDARCH}
259 do
260 [ "${ARCH}" == "${i}" ] && H_ACCEPT_ARCH="yes"
261 done
262
263 if [ "${H_ACCEPT_ARCH}" != "yes" ]
264 then
265 echo
266 eerror "This version of ${PN} does not support ${ARCH}." 689 eerror "This version of ${PN} does not support $(tc-arch)."
267 eerror "Please merge the appropriate sources, in most cases" 690 eerror "Please merge the appropriate sources, in most cases"
268 eerror "this will be ${ARCH}-headers." 691 eerror "(but not all) this will be called $(tc-arch)-headers."
269 die "incorrect headers" 692 die "Package unsupported for $(tc-arch)"
270 fi 693 fi
271} 694}
272 695
273# unipatch 696# unipatch
274#============================================================== 697#==============================================================
275unipatch() { 698unipatch() {
276 local i 699 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
277 local x 700 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
278 local extention 701
279 local PIPE_CMD 702 # set to a standard locale to ensure sorts are ordered properly.
280 local UNIPATCH_EXCLUDE 703 myLC_ALL="${LC_ALL}"
281 local KPATCH_DIR 704 myLANG="${LANG}"
282 local PATCH_DEPTH 705 LC_ALL="C"
283 local ELINE 706 LANG=""
284 707
285 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 708 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
286 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 709 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
287 710
711 # We're gonna need it when doing patches with a predefined patchlevel
712 extglob_bak=$(shopt -p extglob)
713 shopt -s extglob
714
288 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 715 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
289 # usage can be either via an env var or by params 716 # usage can be either via an env var or by params
717 # although due to the nature we pass this within this eclass
718 # it shall be by param only.
290 [ -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 719 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
720 UNIPATCH_LIST="${@}"
291 721
292 #unpack any passed tarballs 722 #unpack any passed tarballs
293 for i in ${UNIPATCH_LIST} 723 for i in ${UNIPATCH_LIST}; do
294 do
295 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ] 724 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
296 then 725 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
726 unset z
727 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
728 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
729 do z="${z}0";
730 done
731 PATCH_ORDER="${z}${STRICT_COUNT}"
732
733 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
734 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
735 unpack ${i##*/}
736 popd >/dev/null
737 else
738 pushd "${KPATCH_DIR}" >/dev/null
739 unpack ${i##*/}
740 popd >/dev/null
741 fi
742
743 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
744 else
297 extention=${i/*./} 745 extention=${i/*./}
746 extention=${extention/:*/}
747 PIPE_CMD=""
298 case ${extention} in 748 case ${extention} in
299 tbz2) PIPE_CMD="tar -xvjf";; 749 bz2) PIPE_CMD="bzip2 -dc";;
300 bz2) PIPE_CMD="tar -xvjf";; 750 patch) PIPE_CMD="cat";;
301 tgz) PIPE_CMD="tar -xvzf";; 751 diff) PIPE_CMD="cat";;
302 gz) PIPE_CMD="tar -xvzf";; 752 gz|Z|z) PIPE_CMD="gzip -dc";;
303 *) eerror "Unrecognized tarball compression" 753 ZIP|zip) PIPE_CMD="unzip -p";;
304 die "Unrecognized tarball compression";; 754 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
305 esac 755 esac
306 756
307 ${PIPE_CMD} ${i} -C ${KPATCH_DIR} 1>/dev/null 757 PATCH_LEVEL=${i/*([^:])?(:)}
308 if [ $? == 0 ] 758 i=${i/:*/}
309 then 759 x=${i/*\//}
310 einfo "${i/*\//} unpacked" 760 x=${x/\.${extention}/}
761
762 if [ -n "${PIPE_CMD}" ]; then
763 if [ ! -r "${i}" ]; then
764 echo
765 eerror "FATAL: unable to locate:"
766 eerror "${i}"
767 eerror "for read-only. The file either has incorrect permissions"
768 eerror "or does not exist."
769 die Unable to locate ${i}
770 fi
771
772 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
773 unset z
774 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
775 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
776 do z="${z}0";
777 done
778 PATCH_ORDER="${z}${STRICT_COUNT}"
779
780 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
781 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL})
311 else 782 else
312 eerror "Failed to unpack ${i}" 783 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL})
313 die "unable to unpack patch tarball" 784 fi
314 fi 785 fi
315
316 UNIPATCH_LIST="${UNIPATCH_LIST/${i}/}"
317 fi 786 fi
318 done
319
320 #so now everything is unpacked, lets work out whats to be dropped and whats to be included.
321 for i in ${UNIPATCH_LIST}
322 do
323 extention=${i/*./}
324 PIPE_CMD=""
325 case ${extention} in
326 bz2) PIPE_CMD="bzip2 -dc";;
327 patch) PIPE_CMD="cat";;
328 diff) PIPE_CMD="cat";;
329 gz|Z|z) PIPE_CMD="gzip -dc";;
330 ZIP|zip) PIPE_CMD="unzip -p";;
331 *) UNIPATCH_EXCLUDE="${UNIPATCH_EXCLUDE} ${i}";;
332 esac
333 x=${i/*\//}
334 x=${x/\.${extention}/}
335 [ -n "${PIPE_CMD}" ] && ${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch
336 done 787 done
337 788
338 #populate KPATCH_DIRS so we know where to look to remove the excludes 789 #populate KPATCH_DIRS so we know where to look to remove the excludes
339 x=${KPATCH_DIR} 790 x=${KPATCH_DIR}
340 KPATCH_DIR="" 791 KPATCH_DIR=""
341 for i in $(find ${x} -type d) 792 for i in $(find ${x} -type d | sort -n); do
342 do
343 KPATCH_DIR="${KPATCH_DIR} ${i}" 793 KPATCH_DIR="${KPATCH_DIR} ${i}"
344 done 794 done
345 795
346 #so now lets get rid of the patchno's we want to exclude 796 #so now lets get rid of the patchno's we want to exclude
797 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
347 for i in ${UNIPATCH_EXCLUDE} 798 for i in ${UNIPATCH_DROP}; do
348 do
349 for x in ${KPATCH_DIR}
350 do
351 rm ${x}/${i}_* 2>/dev/null
352 if [ $? == 0 ]
353 then
354 einfo "Excluding Patch #${i}" 799 ebegin "Excluding Patch #${i}"
355 einfo "From: ${x/${WORKDIR}/}" 800 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
356 fi 801 eend $?
357 done
358 done 802 done
359 803
360 # and now, finally, we patch it :) 804 # and now, finally, we patch it :)
361 for x in ${KPATCH_DIR} 805 for x in ${KPATCH_DIR}; do
362 do
363 for i in $(find ${x} -maxdepth 1 -iname "*.patch" -or -iname "*.diff" | sort -u) 806 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
364 do 807 STDERR_T="${T}/${i/*\//}"
808 STDERR_T="${STDERR_T/.patch*/.err}"
365 809
810 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
811 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
366 812
367 PATCH_DEPTH=0 813 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
814
368 ebegin "Applying ${i/*\//}" 815 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
369 while [ ${PATCH_DEPTH} -lt 5 ] 816 while [ ${PATCH_DEPTH} -lt 5 ]; do
370 do 817 echo "Attempting Dry-run:" >> ${STDERR_T}
371 if (patch -p${PATCH_DEPTH} --dry-run -f < ${i} >/dev/null) 818 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
372 then 819 echo "=======================================================" >> ${STDERR_T}
373 $(patch -p${PATCH_DEPTH} -f < ${i} >/dev/null) 820 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
374 if [ "$?" -eq 0 ] 821 echo "Attempting patch:" > ${STDERR_T}
375 then 822 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
823 echo "=======================================================" >> ${STDERR_T}
824 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
376 eend 0 825 eend 0
826 rm ${STDERR_T}
377 break 827 break
378 else 828 else
379 eend 1 829 eend 1
380 eerror "Failed to apply patch ${i/*\//}" 830 eerror "Failed to apply patch ${i/*\//}"
831 eerror "Please attach ${STDERR_T} to any bug you may post."
381 die "Failed to apply ${i/*\//}" 832 die "Failed to apply ${i/*\//}"
382 fi 833 fi
383 else 834 else
384 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 835 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
385 fi 836 fi
386 done 837 done
387 if [ ${PATCH_DEPTH} -eq 5 ] 838 if [ ${PATCH_DEPTH} -eq 5 ]; then
388 then
389 eend 1 839 eend 1
840 eerror "Please attach ${STDERR_T} to any bug you may post."
390 die "Unable to dry-run patch." 841 die "Unable to dry-run patch."
391 fi 842 fi
392
393
394 done 843 done
395 done 844 done
396}
397 845
398# custom functions 846 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
399#============================================================== 847 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
400detect_version() { 848 # which is why I'm not taking too much time over this.
401 # this function will detect and set 849 local tmp
402 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 850 for i in ${UNIPATCH_DOCS}; do
403 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 851 tmp="${tmp} ${i//*\/}"
404 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 852 cp -f ${i} ${T}/
405 853 done
406 OKV=${PV/_beta/-test} 854 UNIPATCH_DOCS="${tmp}"
407 OKV=${OKV/_rc/-rc} 855
408 OKV=${OKV/_pre*/} 856 # clean up KPATCH_DIR's - fixes bug #53610
409 OKV=${OKV/-r*/} 857 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
410 858
411 KV_MAJOR=$(echo ${OKV} | cut -d. -f1) 859 LC_ALL="${myLC_ALL}"
412 KV_MINOR=$(echo ${OKV} | cut -d. -f2) 860 LANG="${myLANG}"
413 KV_PATCH=$(echo ${OKV} | cut -d. -f3) 861 eval ${extglob_bak}
414 KV_PATCH=${KV_PATCH/[-_]*/} 862}
415 863
416 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 864# getfilevar accepts 2 vars as follows:
417 865# getfilevar <VARIABLE> <CONFIGFILE>
418 RELEASE=${PV/${OKV}/} 866# pulled from linux-info
419 RELEASE=${RELEASE/_beta/} 867
420 RELEASE=${RELEASE/_rc/-rc} 868getfilevar() {
421 RELEASE=${RELEASE/_pre/-bk} 869 local workingdir basefname basedname xarch=$(tc-arch-kernel)
422 RELEASETYPE=${RELEASE//[0-9]/} 870
423 871 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
424 EXTRAVERSION="${RELEASE}" 872 echo -e "\n"
425 873 eerror "getfilevar requires 2 variables, with the second a valid file."
426 if [ -n "${K_PREPATCHED}" ] 874 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
427 then
428 KV="${OKV}-${PN/-*/}${PR/r/}"
429 else 875 else
430 [ -z "${K_NOUSENAME}" ] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}" 876 workingdir=${PWD}
431 [ ! "${PR}" == "r0" ] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 877 basefname=$(basename ${2})
432 878 basedname=$(dirname ${2})
433 KV=${OKV}${EXTRAVERSION} 879 unset ARCH
880
881 cd ${basedname}
882 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
883 make ${BUILD_FIXES} -s -f - e 2>/dev/null
884 cd ${workingdir}
885
886 ARCH=${xarch}
887 fi
888}
889
890detect_arch() {
891 # This function sets ARCH_URI and ARCH_PATCH
892 # with the neccessary info for the arch sepecific compatibility
893 # patchsets.
894
895 local ALL_ARCH LOOP_ARCH COMPAT_URI i
896
897 # COMPAT_URI is the contents of ${ARCH}_URI
898 # ARCH_URI is the URI for all the ${ARCH}_URI patches
899 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
900
901 ARCH_URI=""
902 ARCH_PATCH=""
903 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
904
905 for LOOP_ARCH in ${ALL_ARCH}; do
906 COMPAT_URI="${LOOP_ARCH}_URI"
907 COMPAT_URI="${!COMPAT_URI}"
908
909 [[ -n ${COMPAT_URI} ]] && \
910 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
911
912 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
913 for i in ${COMPAT_URI}; do
914 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
915 done
434 fi 916 fi
435 917 done
436 # -rcXX-bkXX pulls are *IMPOSSIBLE* to support within the portage naming convention 918}
437 # these cannot be supported, but the code here can handle it up until this point 919
438 # and theoretically thereafter. 920# sparc nastiness
439 921#==============================================================
440 if [ "${RELEASETYPE}" == "-rc" ] 922# This script generates the files in /usr/include/asm for sparc systems
441 then 923# during installation of sys-kernel/linux-headers.
442 OKV="${KV_MAJOR}.${KV_MINOR}.$([ $((${KV_PATCH} - 1)) -lt 0 ] && echo ${KV_PATCH} || echo $((${KV_PATCH} - 1)))" 924# Will no longer be needed when full 64 bit support is used on sparc64
443 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${PV//_/-}.bz2 925# systems.
444 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 926#
445 UNIPATCH_LIST="${DISTDIR}/patch-${PV//_/-}.bz2 ${UNIPATCH_LIST}" 927# Shamefully ripped from Debian
446 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION} 928# ----------------------------------------------------------------------
929
930# Idea borrowed from RedHat's kernel package
931
932# This is gonna get replaced by something in multilib.eclass soon...
933# --eradicator
934generate_sparc_asm() {
935 local name
936
937 cd $1 || die
938 mkdir asm
939
940 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
941 name="$(echo $h | tr a-z. A-Z_)"
942 # common header
943 echo "/* All asm/ files are generated and point to the corresponding
944 * file in asm-sparc or asm-sparc64.
945 */
946
947#ifndef __SPARCSTUB__${name}__
948#define __SPARCSTUB__${name}__
949" > asm/${h}
950
951 # common for sparc and sparc64
952 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
953 echo "#ifdef __arch64__
954#include <asm-sparc64/$h>
955#else
956#include <asm-sparc/$h>
957#endif
958" >> asm/${h}
959
960 # sparc only
961 elif [ -f asm-sparc/$h ]; then
962echo "#ifndef __arch64__
963#include <asm-sparc/$h>
964#endif
965" >> asm/${h}
966
967 # sparc64 only
968 else
969echo "#ifdef __arch64__
970#include <asm-sparc64/$h>
971#endif
972" >> asm/${h}
447 fi 973 fi
448
449 if [ "${RELEASETYPE}" == "-bk" ]
450 then
451 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
452 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
453 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
454 UNIPATCH_LIST="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 ${UNIPATCH_LIST}"
455 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION}
456 fi
457
458 if [ "${RELEASETYPE}" == "-rc-bk" ]
459 then
460 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))-${RELEASE/-bk*}"
461 EXTRAVERSION="$([ -n "${RELEASE}" ] && echo ${RELEASE/*-bk/-bk})$([ -n "${K_USENAME}" ] && echo -${PN/-*/})$([ ! "${PR}" == "r0" ] && echo -${PR})"
462
463 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
464 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
465 UNIPATCH_LIST="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 ${UNIPATCH_LIST}"
466 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION}
467 fi
468
469 S=${WORKDIR}/linux-${KV}
470}
471 974
975 # common footer
976 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
977 done
978 return 0
979}
980
981headers___fix() {
982 # Voodoo to partially fix broken upstream headers.
983 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
984 sed -i \
985 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
986 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
987 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
988 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
989 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
990 "$@"
991}
472 992
473# common functions 993# common functions
474#============================================================== 994#==============================================================
475src_unpack() { 995kernel-2_src_unpack() {
476 [ -z "${OKV}" ] && OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
477
478 cd ${WORKDIR}
479 unpack linux-${OKV}.tar.bz2
480 if [ "${OKV}" != "${KV}" ]
481 then
482 mv linux-${OKV} linux-${KV} || die "Unable to move source tree to ${KV}."
483 fi
484 cd ${S}
485
486 universal_unpack 996 universal_unpack
487 [ -n "${UNIPATCH_LIST}" ] && unipatch ${UNIPATCH_LIST} 997 debug-print "Doing unipatch"
998
999 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1000 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1001
1002 debug-print "Doing premake"
1003
1004 # allow ebuilds to massage the source tree after patching but before
1005 # we run misc `make` functions below
1006 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1007
1008 debug-print "Doing unpack_set_extraversion"
1009
488 [ -z "${K_NOSETEXTRAVERSION}" ] && unpack_set_extraversion 1010 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1011 unpack_fix_install_path
489 1012
490 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 1013 # Setup xmakeopts and cd into sourcetree.
491} 1014 env_setup_xmakeopts
1015 cd "${S}"
492 1016
1017 # We dont need a version.h for anything other than headers
1018 # at least, I should hope we dont. If this causes problems
1019 # take out the if/fi block and inform me please.
1020 # unpack_2_6 should now be 2.6.17 safe anyways
1021 if [[ ${ETYPE} == headers ]]; then
1022 kernel_is 2 4 && unpack_2_4
1023 kernel_is 2 6 && unpack_2_6
1024 fi
1025}
1026
493src_compile() { 1027kernel-2_src_compile() {
1028 cd "${S}"
494 [ "${ETYPE}" == "headers" ] && compile_headers 1029 [[ ${ETYPE} == headers ]] && compile_headers
495} 1030}
496 1031
497pkg_preinst() { 1032kernel-2_pkg_preinst() {
498 [ "${ETYPE}" == "headers" ] && preinst_headers 1033 [[ ${ETYPE} == headers ]] && preinst_headers
499} 1034}
500 1035
501src_install() { 1036kernel-2_src_install() {
502 install_universal 1037 install_universal
503 [ "${ETYPE}" == "headers" ] && install_headers 1038 [[ ${ETYPE} == headers ]] && install_headers
504 [ "${ETYPE}" == "sources" ] && install_sources 1039 [[ ${ETYPE} == sources ]] && install_sources
505} 1040}
506 1041
507pkg_postinst() { 1042kernel-2_pkg_postinst() {
508 [ "${ETYPE}" == "headers" ] && postinst_headers 1043 [[ ${ETYPE} == headers ]] && postinst_headers
509 [ "${ETYPE}" == "sources" ] && postinst_sources 1044 [[ ${ETYPE} == sources ]] && postinst_sources
510} 1045}
511 1046
512pkg_setup() { 1047kernel-2_pkg_setup() {
1048 if kernel_is 2 4; then
1049 if [ "$( gcc-major-version )" -eq "4" ] ; then
1050 echo
1051 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1052 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1053 ewarn "newer kernel that supports gcc-4."
1054 echo
1055 ewarn "Also be aware that bugreports about gcc-4 not working"
1056 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1057 echo
1058 epause 10
1059 fi
1060 fi
1061
1062 ABI="${KERNEL_ABI}"
513 [ "${ETYPE}" == "headers" ] && setup_headers 1063 [[ ${ETYPE} == headers ]] && setup_headers
1064 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
514} 1065}

Legend:
Removed from v.1.12  
changed lines
  Added in v.1.212

  ViewVC Help
Powered by ViewVC 1.1.20